#' PARESTHESIA RATES WITH TOPIRAMATE IN MIGRAINE PROPHYLAXIS TRIALS
#'
#' Numbers of patients and events (paresthesia rates)
#' in experimental and control groups of 6 studies.
#' It is in one-study-per-row format. Only the arm with 200 mg
#' is included.
#'
#' @format A data frame with following coloumns
#' \describe{
#'   \item{study}{Study ID}
#'   \item{duration}{Durtaion of the study}
#'   \item{r1}{number of events in the first arm (placebo)}
#'   \item{n1}{number of patients in the first arm (placebo)}
#'   \item{r2}{number of events in the second arm}
#'   \item{n2}{number of patients in the second arm}
#'  }
#' @source Boucher M, and Bennets M. The Many Flavors of
#' Model-Based Meta-Analysis: Part I - Introduction and
#' Landmark Data.
#' CPT Pharmacometrics Syst. Pharmacol. (2016) 5, 54-64;
#' doi:10.1002/psp4.12041
#'
"dat.Boucher2016.pairwise"

