#' Migraine pain relief example (Eletriptan)
#'
#' Numbers of patients and events (headcahe free at 2 hours)
#' in experimental and control groups of 12 studies.
#' It is in one-study-per-row format.
#'
#' @format A data frame with following coloumns
#' \describe{
#'   \item{ID}{trial ID}
#'   \item{d1}{dose (mg) in the first arm (placebo)}
#'   \item{r1}{number of events in the first arm (placebo)}
#'   \item{n1}{number of patients in the first arm (placebo)}
#'   \item{d2}{dose (mg) in the second arm }
#'   \item{r2}{number of events in the second arm}
#'   \item{n2}{number of patients in the second arm}
#'   \item{d3}{dose (mg) in the third arm}
#'   \item{r3}{number of events in the third arm}
#'   \item{n3}{number of patients in the third arm}
#'   \item{d4}{dose (mg) in the fourth arm}
#'   \item{r4}{number of events in the fourth arm}
#'   \item{n4}{number of patients in the fourth arm}
#'   \item{nd}{number of treatment arms}
#'  }
#' @source Thorlund, K., Mills, E., Wu, P., Ramos, E.,
#'  Chatterjee, A., Druyts, E., and Goadsby, P. (2014).
#'  Comparative efficacy of triptans for the abortive treatment
#'  of migraine: A multiple treatment comparison meta-analysis.
#'  Cephalalgia, 34(4):258-267.
"dat.Eletriptan"

